package application;
	
import javafx.application.Application;
import javafx.fxml.FXMLLoader;
import javafx.stage.Stage;
import javafx.scene.Parent;
import javafx.scene.Scene;

public class Main extends Application {
	@Override
	/**
	   * This method load the window view of the calculator
	   * @param Stage primary stage to show the view
	   */
	public void start(Stage primaryStage) {
		try {
			Parent root = FXMLLoader.load(getClass().getResource("WindowView.fxml"));
			Scene scene = new Scene(root);
			primaryStage.setScene(scene);
			primaryStage.show();
			System.out.println(Thread.currentThread().getName());
			
			
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	/**
	   * This method launch the application
	   * @param String of arguments
	   */
	public static void main(String[] args) {
		launch(args);
	}
}