public class ContainerHelper {
    private static void ensurePositiveOrNull(int... values) { 
        for (int v: values) {
            ensurePositiveOrNull(v);
        }
    }
    private static void ensurePositiveOrNull(int value) {
        if (value < 0) {
            throw new UnsupportedOperationException("Value should be positive: " + value);
        }
    }

    public static int canTransfer(int origin, int destination) {
        return Math.min(origin, destination);
    }

    public static int[] transfer(int origin, final int dest1, final int... dests) {
        ensurePositiveOrNull(new int[]{origin, dest1});
        ensurePositiveOrNull(dests);
        final int[] res = new int[dests.length+1];
        int quantityToTransfer = canTransfer(origin, dest1);
        origin -= quantityToTransfer;
        res[0] = quantityToTransfer;
        for(int i = 0; i < dests.length; i += 1) {
            quantityToTransfer = canTransfer(origin, dests[i]);
            origin -= quantityToTransfer;
            res[i+1] = quantityToTransfer;
        }
        return res;
    }
}