public class DynArray {

    private int[] values = {};
    
    private DynArray() {}
    private DynArray(int[] values) {
        this.values = values;
    }

    public static DynArray of(int... values) {
        return new DynArray(values);
    }

    public DynArray append(int value) {
        DynArray res = new DynArray(this.values);
        res.values = append(res.values, value);
        return res;
    }
    public int head() {
        return head(this.values);
    }
    public DynArray pop() {
        return new DynArray(pop(this.values));
    }
    public DynArray concat(DynArray that) {
        return new DynArray(concat(this.values, that.values));
    }
    public int size() {
        return this.values.length;
    }
    public DynArray reversed() {
        return new DynArray(reversed(this.values));
    }
    public String toString() {
        String res = "[";
        for (int i = 0; i < this.values.length; i += 1 ) {
            if (i == 0) {
                res += this.values[i];
            } else {
                res += "," + this.values[i];
            }
        }
        return res + "]";
    }
    public int hashCode() {
        return this.values.hashCode();
    }
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || this.getClass() != o.getClass()) {
            return false;
        }
        DynArray d = (DynArray)o;
        return Arrays.equals(this.values, d.values);
    }

    private static int[] reversed(int[] values) {
        int[] result = new int[values.length];
        for (int i = 0; i < values.length; i += 1) {
            result[values.length-1-i] = values[i];
        }
        return result;
    }

    private static int[] append(int[] values, int value) {
        int[] result = new int[values.length+1];
        result[0] = value;
        for (int i = 0; i < values.length; i += 1) {
            result[i+1] = values[i];
        }
        return result;
    }
    private static int head(int[] values) {
        return values[0];
    }
    private static int[] pop(int[] values) {
        int[] result = new int[values.length-1];
        for (int i = 0; i < result.length; i += 1) {
            result[i] = values[i+1];
        }
        return result;
    }
    private static int[] concat(int[] is, int[] js) { 
        for (int i = is.length-1; i >= 0; i -= 1) {
            js = append(js, is[i]);
        }
        return js;
    }


    public static void main(String[] args) {
        DynArray is = DynArray.of(1, 2, 2, -1, 5); 
        // is = [1, 2, 2, -1, 5]; 
        DynArray is2 = is.append(10);
        // is2 = [10, 1, 2, 2, -1, 5]; 
        int j = is2.head();
        // j = 10
        DynArray tail = is2.pop();
        // tail = [1, 2, 2, -1, 5];
        DynArray rev = tail.reversed();
        // tail = [5, -1, 2, 2, 1]
        int size = rev.size();
        // size = 5
        boolean areEquals = is.equals(tail);
        // areEquals = true
        DynArray result = is2.concat( DynArray.of(4,3,2) ); 
        // result = [10, 1, 2, 2, -1, 5, 4, 3, 2]
        String representation = result.toString(); 
        // representation = [10, 1, 2, 2, -1, 5, 4, 3, 2]
    }

}