import java.time.LocalDateTime;
import java.time.Month;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Random;

public class IndividuUtils {

    private static final Random RANDOM = new Random();

    public static Individu createIndividu() {
        int taille = 150 + RANDOM.nextInt(41);
        int poids = 60 + RANDOM.nextInt(41);

        int year = 1990 + RANDOM.nextInt(35);
        int month = 1 + RANDOM.nextInt(12);
        int day = 1 + RANDOM.nextInt(
            LocalDateTime.of(
                year, month, 1, 0, 0).getMonth().length(false)
            );
        int hour = RANDOM.nextInt(24);
        int minute = RANDOM.nextInt(60);

        LocalDateTime dateDeNaissance = LocalDateTime.of(year, month, day, hour, minute);

        Individu.LieuxDeNaissance lieuDeNaissance = Individu.LieuxDeNaissance.values()[
            RANDOM.nextInt(Individu.LieuxDeNaissance.values().length)
        ];

        List<Individu.Hobbies> hobbiesList = Arrays.asList(Individu.Hobbies.values());
        List<Individu.Hobbies> hobbies = new ArrayList<>();
        int numberOfHobbies = 1 + RANDOM.nextInt(hobbiesList.size());

        for (int i = 0; i < numberOfHobbies; i++) {
            Individu.Hobbies hobby;
            do {
                hobby = hobbiesList.get(RANDOM.nextInt(hobbiesList.size()));
            } while (hobbies.contains(hobby));
            hobbies.add(hobby);
        }

        return new Individu(taille, dateDeNaissance, lieuDeNaissance, poids, hobbies);
    }

    public static List<Individu> createIndividus(int n) {
        List<Individu> individus = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            individus.add(createIndividu());
        }
        return individus;
    }
}
