import java.time.Month;
import java.util.*;
import java.util.stream.Collectors;

public class Test1 {
    public static void main(String[] args) {
        // Générer une liste de 100 individus aléatoires
        List<Individu> individus = IndividuUtils.createIndividus(100);

        // 1. Afficher tous les individus nés en 2000 au mois de mars
        System.out.println("Individus nés en 2000 au mois de mars :");
        individus.stream()
                .filter(i -> i.getDateDeNaissance().getYear() == 2000)
                .filter(i -> i.getDateDeNaissance().getMonth() == Month.MARCH)
                .forEach(System.out::println);

        // 2. Afficher les 5 premiers individus nés en juillet 1993
        System.out.println("\nLes 5 premiers individus nés en juillet 1993 :");
        individus.stream()
                .filter(i -> i.getDateDeNaissance().getYear() == 1993)
                .filter(i -> i.getDateDeNaissance().getMonth() == Month.JULY)
                .limit(5)
                .forEach(System.out::println);

        // 3. Afficher le nombre total d'individus nés en 1994
        long count1994 = individus.stream()
                .filter(i -> i.getDateDeNaissance().getYear() == 1994)
                .count();
        System.out.println("\nNombre total d'individus nés en 1994 : " + count1994);

        // 4. Afficher les 5 plus grands individus nés au mois de décembre de l'année 2001
        System.out.println("\nLes 5 plus grands individus nés en décembre 2001 :");
        individus.stream()
                .filter(i -> i.getDateDeNaissance().getYear() == 2001)
                .filter(i -> i.getDateDeNaissance().getMonth() == Month.DECEMBER)
                .sorted(Comparator.comparingInt(Individu::getTaille).reversed())
                .limit(5)
                .forEach(System.out::println);

        // 5. Afficher les 5 plus petits individus de taille au moins 180cm nés en 2002
        System.out.println("\nLes 5 plus petits individus (≥ 180cm) nés en 2002 :");
        individus.stream()
                .filter(i -> i.getDateDeNaissance().getYear() == 2002)
                .filter(i -> i.getTaille() >= 180)
                .sorted(Comparator.comparingInt(Individu::getTaille))
                .limit(5)
                .forEach(System.out::println);

        // 6. Afficher les 5 plus petits individus de taille au moins 180cm nés en 2002 par ordre décroissant de taille
        System.out.println("\nLes 5 plus petits individus (≥ 180cm) nés en 2002 (ordre décroissant) :");
        individus.stream()
                .filter(i -> i.getDateDeNaissance().getYear() == 2002)
                .filter(i -> i.getTaille() >= 180)
                .sorted(Comparator.comparingInt(Individu::getTaille).reversed())
                .limit(5)
                .forEach(System.out::println);

        // 7. Afficher la liste (sans redondance) des hobbies des 5 plus lourds parmi les 20 plus grands individus nés en 1999
        System.out.println("\nHobbies (sans redondance) des 5 plus lourds parmi les 20 plus grands nés en 1999 :");
        individus.stream()
                .filter(i -> i.getDateDeNaissance().getYear() == 1999)
                .sorted(Comparator.comparingInt(Individu::getTaille).reversed())
                .limit(20)
                .sorted(Comparator.comparingInt(Individu::getPoids).reversed())
                .limit(5)
                .flatMap(i -> i.getHobbies().stream())
                .distinct()
                .forEach(System.out::println);

        // 8. Afficher la liste (sans redondance) des mois de naissance des 20 plus grands individus nés en 1997
        System.out.println("\nMois de naissance (sans redondance) des 20 plus grands nés en 1997 :");
        individus.stream()
                .filter(i -> i.getDateDeNaissance().getYear() == 1997)
                .sorted(Comparator.comparingInt(Individu::getTaille).reversed())
                .limit(20)
                .map(i -> i.getDateDeNaissance().getMonth())
                .distinct()
                .forEach(System.out::println);
    }
}
